/*-
 * Copyright (c) 2010 Rui Paulo <rpaulo@FreeBSD.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <sys/cdefs.h>
__FBSDID("$FreeBSD: release/9.2.0/sys/boot/i386/efi/exec.c 206376 2010-04-07 18:16:05Z rpaulo $");

#include <stand.h>
#include <machine/elf.h>
#include "../btx/lib/btxv86.h"

#include "../../common/bootstrap.h"

uint32_t __base;
struct __v86 __v86;

void
__v86int()
{
	printf("%s\n", __func__);
	exit(1);
}

void
__exec(caddr_t addr, ...)
{
	/* XXX this is wrong */
	__asm __volatile("movl %cr0, %eax");
	__asm __volatile("andl $0x7fffffff, %eax");
	__asm __volatile("mov %eax, %cr0");
	__asm __volatile("xorl %eax, %eax");
	__asm __volatile("mov %eax, %cr3");
	__asm __volatile("movl %cr0, %eax");
	__asm __volatile("andl $0xfffffffe, %eax");
	__asm __volatile("movl %eax, %cr0");
	__asm __volatile("jmp %0" :: "r" (addr));
}
